;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;
; NAME: init_path2.pro
;
; PURPOSE: File Path required for INTERP2
;
; CATEGORY : Namelist
;
; CALLING SEQUENCE : @init_path2
;
; COMMON BLOCKS:
;         None
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY: 08/2002 Robinson Hordoir
;
;------------------------------------------------------------
;------------------------------------------------------------


;---------------------------------------------------
; INTERP2 : PATH INITIALISATIONS                            *
;---------------------------------------------------
;
; 1. Directories
; ==============
;

   input_dir = '/usr/work/sur/fvi/OPA/ORCA2'
   output_dir = '/usr/work/sur/fvi/OPA/ORCA2'

;
; 2. Input information 
; ====================
;
;  2.1. Data file name
;  -------------------
;
 

   datafile = 'ForcageMOED_5d_1993_grid_T.nc'
   outputfile = 'ForcMOED_Sigma_1993_reg.nc'

;   datafile = 'DivBustar_5d_1993_grid_T.nc'
;   outputfile = 'DivBustar_5d_1993_reg.nc'
;   datafile = 'Sigma_5d_1998_grid_T.nc'
;   outputfile = 'Sigma_5d_1998_reg.nc'
;
;  2.2. Input ORCA Meshmask file name
;  ------------------------
;

   inputmesh = 'meshmask_bab.nc'

;
; 3. Output information  
; =====================
;
;  3.1. Output geogrid meshmask (please print the name you want to
;  give to this file, even if you do not have it yet)
;  ----------------------------
;
   outputgrid = 'mask_reg.nc'

;  3.2. Weight file required for interpolation (please print the name you want to
;  give to this file, even if you do not have it yet)
;  ----------------------------
;
   weightfile = 'weight_ORCA2_grid_T.nc'


;
;  3.3. Output file name
;  ---------------------
;
;;;;   outputfile = 'DivBustar_5d_1998_reg.nc'
 

;
;  3.4  Error file in weight calculation
;  -------------------------------------
;

   errorfile='error_wT'
   
;*************** END OF USER'S PART *******************
;********DO NOT MODIFY ANYTHING BELLOW THIS LINE*******
;******************************************************


datafile   = string(input_dir,'/',datafile)
inputmesh  = string(input_dir,'/',inputmesh)
outputgrid = string(output_dir,'/',outputgrid)
weightfile = string(output_dir,'/',weightfile)
outputfile = string(output_dir,'/',outputfile)
errorfile  = string(output_dir,'/',errorfile)


;*****************************************************

